"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var merge = require("deepmerge");
var fileUrl = require("file-url");
var path = require("path");
var phantom = require("phantom");
var request = require("request");
/**
 * Can be used to mock Recurly.js functionality during automated testing.
 */
var RecurlyJsMock = (function () {
    function RecurlyJsMock() {
    }
    /**
     * Spins up a headless browser instance, creates a Recurly.js compliant form,
     * inputs the desired data and returns the Recurly.js token.
     *
     * @param publicApiKey The public API key of the Recurly account to be used
     * @param logLevel The desired log level. Can be debug, info, warn or error.
     * @param details The payment information to be used to fill out the form
     */
    RecurlyJsMock.getTokenSingleRun = function (publicApiKey, logLevel, details) {
        var _this = this;
        if (logLevel === void 0) { logLevel = LogLevel.Error; }
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var instance, page, status, content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, phantom.create(["--web-security=no"], { logLevel: RecurlyJsMock.getLogLevelConfiguration(logLevel) })];
                    case 1:
                        instance = _a.sent();
                        return [4 /*yield*/, instance.createPage()];
                    case 2:
                        page = _a.sent();
                        /*
                         * Listen for callbacks from client JS. This is used to detect when Recurly.js
                         * has finished processing payment information and the token is ready to
                         * be collected.
                         */
                        return [4 /*yield*/, page.on("onCallback", function (data) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _a = data.status;
                                            switch (_a) {
                                                case "success": return [3 /*break*/, 1];
                                                case "error": return [3 /*break*/, 3];
                                            }
                                            return [3 /*break*/, 5];
                                        case 1:
                                            resolve(data.token);
                                            return [4 /*yield*/, instance.exit()];
                                        case 2:
                                            _b.sent();
                                            return [3 /*break*/, 7];
                                        case 3:
                                            reject(data.err);
                                            return [4 /*yield*/, instance.exit(1)];
                                        case 4:
                                            _b.sent();
                                            return [3 /*break*/, 7];
                                        case 5:
                                            reject();
                                            return [4 /*yield*/, instance.exit(2)];
                                        case 6:
                                            _b.sent();
                                            return [3 /*break*/, 7];
                                        case 7: return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 3:
                        /*
                         * Listen for callbacks from client JS. This is used to detect when Recurly.js
                         * has finished processing payment information and the token is ready to
                         * be collected.
                         */
                        _a.sent();
                        /*
                         * Listen to resource requested events for debugging purposes.
                         */
                        return [4 /*yield*/, page.on("onResourceRequested", function (requestData) {
                                instance.logger.debug("Requesting", requestData.url);
                            })];
                    case 4:
                        /*
                         * Listen to resource requested events for debugging purposes.
                         */
                        _a.sent();
                        return [4 /*yield*/, page.open(fileUrl(path.resolve(__dirname, "recurlyJsMock.html")))];
                    case 5:
                        status = _a.sent();
                        instance.logger.debug(status);
                        /*
                         * Load required JS libraries.
                         */
                        return [4 /*yield*/, page.includeJs("http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js")];
                    case 6:
                        /*
                         * Load required JS libraries.
                         */
                        _a.sent();
                        return [4 /*yield*/, page.includeJs("https://js.recurly.com/v4/recurly.js")];
                    case 7:
                        _a.sent();
                        /*
                         * Configure Recurly.js
                         */
                        return [4 /*yield*/, page.evaluate(function (key) {
                                recurly.configure({
                                    publicKey: key
                                });
                            }, publicApiKey)];
                    case 8:
                        /*
                         * Configure Recurly.js
                         */
                        _a.sent();
                        return [4 /*yield*/, page.property("content")];
                    case 9:
                        content = _a.sent();
                        instance.logger.debug(content);
                        // Listen for Recurly.js
                        return [4 /*yield*/, page.evaluate(function () {
                                // On form submit, we stop submission to get the token
                                $("form").on("submit", function (event) {
                                    // Prevent the form from submitting while we retrieve the token from Recurly
                                    event.preventDefault();
                                    var form = this;
                                    // Now we call recurly.token with the form. It goes to Recurly servers
                                    // to tokenize the credit card information, then injects the token into the
                                    // data-recurly="token" field above
                                    recurly.token(form, function (err, token) {
                                        var result;
                                        if (err) {
                                            result = { status: "error", err: err };
                                        }
                                        else {
                                            result = { status: "success", token: token };
                                        }
                                        window.callPhantom(result);
                                    });
                                });
                            })];
                    case 10:
                        // Listen for Recurly.js
                        _a.sent();
                        /*
                         * Fill out form and submit
                         */
                        return [4 /*yield*/, page.evaluate(function (paymentDetails) {
                                $("#number iframe").first().contents().find("input").first().val(paymentDetails.cardData.number);
                                $("#month iframe").first().contents().find("input").first().val(paymentDetails.cardData.month);
                                $("#year iframe").first().contents().find("input").first().val(paymentDetails.cardData.year);
                                $("#first_name").val(paymentDetails.cardData.firstName);
                                $("#last_name").val(paymentDetails.cardData.lastName);
                                $("#address1").val(paymentDetails.address1);
                                $("#city").val(paymentDetails.city);
                                $("#country").val(paymentDetails.country);
                                $("#postal_code").val(paymentDetails.postalCode);
                                $("form").submit();
                            }, RecurlyJsMock.mergeWithDefaults(details))];
                    case 11:
                        /*
                         * Fill out form and submit
                         */
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * Returns the Recurly.js token without running a headless browser.
     *
     * @param publicApiKey The public API key of the Recurly account to be used
     * @param logLevel The desired log level. Can be debug, info, warn or error.
     * @param details The payment information to be used
     */
    RecurlyJsMock.getTokenAPICall = function (publicApiKey, logLevel, details) {
        if (logLevel === void 0) { logLevel = LogLevel.Error; }
        if (details == null) {
            details = {};
        }
        return new Promise(function (resolve, reject) {
            var url = "https://api.recurly.com/js/v1/token";
            var data = RecurlyJsMock.mergeWithDefaults(details);
            var formData = {
                address1: data.address1 ? data.address1 : "",
                address2: data.address2 ? data.address2 : "",
                city: data.city ? data.city : "",
                country: data.country ? data.country : "",
                cvv: data.cardData.cvv ? data.cardData.cvv : "",
                first_name: data.cardData.firstName ? data.cardData.firstName : "",
                key: publicApiKey,
                last_name: data.cardData.lastName ? data.cardData.lastName : "",
                month: data.cardData.month ? data.cardData.month : "",
                number: data.cardData.number ? data.cardData.number : "",
                phone: data.phone ? data.phone : "",
                postal_code: data.postalCode ? data.postalCode : "",
                state: data.state ? data.state : "",
                vat_number: data.vatNumber ? data.vatNumber : "",
                year: data.cardData.year ? data.cardData.year : ""
            };
            request.post({ url: url, formData: formData }, function (err, res, body) {
                if (err || res.statusCode !== 200) {
                    reject(err);
                }
                else {
                    body = JSON.parse(body);
                    // Recurly API fails to respond with proper error code
                    if (body.hasOwnProperty("error")) {
                        reject(body.error);
                    }
                    else {
                        resolve(body);
                    }
                }
            });
        });
    };
    RecurlyJsMock.getLogLevelConfiguration = function (logLevel) {
        switch (logLevel) {
            case LogLevel.Debug:
                return "debug";
            case LogLevel.Info:
                return "info";
            case LogLevel.Warn:
                return "warn";
            case LogLevel.Error:
                return "error";
            default:
                return "error";
        }
    };
    RecurlyJsMock.mergeWithDefaults = function (details) {
        var defaults = {
            address1: "Street 1",
            cardData: {
                cvv: 123,
                firstName: "John",
                lastName: "Doe",
                month: 10,
                number: "4111 1111 1111 1111",
                year: 20
            },
            city: "Vienna",
            country: "AT",
            postalCode: "1080"
        };
        RecurlyJsMock.deleteUndefinedProperties(details);
        if (!details) {
            return defaults;
        }
        else {
            return merge(defaults, details);
        }
    };
    /**
     * Deletes undefined values from given details recursively including nested objects.
     */
    RecurlyJsMock.deleteUndefinedProperties = function (obj) {
        Object.keys(obj).forEach(function (key) {
            if (obj[key] && typeof obj[key] === "object") {
                RecurlyJsMock.deleteUndefinedProperties(obj[key]);
            }
            else if (obj[key] == null) {
                delete obj[key];
            }
        });
        return obj;
    };
    RecurlyJsMock.prototype.startDaemon = function (publicApiKey, logLevel) {
        if (logLevel === void 0) { logLevel = LogLevel.Error; }
        throw new Error("Not implemented.");
    };
    RecurlyJsMock.prototype.stopDaemon = function () {
        throw new Error("Not implemented.");
    };
    RecurlyJsMock.prototype.getToken = function (details) {
        throw new Error("Not implemented.");
    };
    return RecurlyJsMock;
}());
exports.RecurlyJsMock = RecurlyJsMock;
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["Debug"] = 0] = "Debug";
    LogLevel[LogLevel["Info"] = 1] = "Info";
    LogLevel[LogLevel["Warn"] = 2] = "Warn";
    LogLevel[LogLevel["Error"] = 3] = "Error";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
//# sourceMappingURL=recurlyJsMock.js.map